        PROGRAM ADJTIME
*******************************************************************************
C   ADDS OR SUB TIME TO AN INPUT NAVIGATION FILE 
c       ADJUSTING JDAY, HRS, MIN, AND SECONDS.

      Implicit none
      logical*1
     +   status,             ! logical for return of funct.
     +   there               ! flag to check the existance of input file

      character
     +   string*24,
     +   in_file*30,                  ! input filename
     +   out_file*30                  ! output filename
  
      integer*4         
     +   sjd, shr, smn, stime, ejd, ehr, emn, etime,
     +   ajd, ahr, amin, asec, adj,
     +   yr, jday, hr, min, sec, time,
     +   jdb, hrb, mnb, secb, ctime, time2hms
      
*******************************************************************************
c     open the input file
c     ---------------------
5     write(6,*)'ENTER NAME OF INPUT FILE.>>>'
      read(5,10) in_file
10    format(A)
         there = .false.
         inquire(file=in_file,exist=there)
         if (.not. there) then
            type *,'FILE NOT THERE: TRY AGAIN !',in_file
            GOTO 5
         else
            type *,'OPENING FILE: ',in_file
         endif
 
         open(unit=1,file=in_file,form='formatted',access=
     +        'sequential',carriagecontrol='list',status='old')

c     open the output file:
c     ---------------------
        write(6,*)'ENTER OUTPUT FILE NAME>>>'
        read(5,10)out_file
        open(unit=2,file=out_file,form='formatted',access=
     +     'sequential',carriagecontrol='list',status='new')

14      WRITE(6,*)'ENTER THE SECONDS TO BE ADDED/SUBTRACTED>>(I4)'
        WRITE(6,*)'ENTER HRMN(I5) <+TO ADD, - TO SUBTRACT>'
        READ(5,15,ERR=14) ADJ
15      FORMAT(I5)

        WRITE(6,*)'ADJ(MIN):', ADJ

        IF(ADJ .EQ. 0)THEN
          WRITE(6,*)' PROGRAM IS NOT ABLE TO HANDLE THIS ADJUSTMENT'
          WRITE(6,*)'ADJ:', ADJ
          GOTO 90
        ENDIF

C
      PRINT *, ' ENTER START TIME FOR CORRECTIONS '
      PRINT *, ' ENTER JULIAN DAY, HR, MIN.'
      READ(5,*) SJD, SHR, SMN
      STIME=SJD*1440*60 + SHR*3600 + SMN*60 
        print *, ' stime:', stime
      PRINT *, ' ENTER END TIME FOR CORRECTIONS '
      PRINT *, ' ENTER JULIAN DAY, HR, MIN.'
      READ(5,*)  EJD, EHR, EMN
      ETIME=EJD*1440*60 + EHR*3600 + EMN*60

c        read the input file:
c        --------------------
        do while(.true.)
65       read(1,70,err=165,end=90) Jday, hr, min, sec, string
70      format(I4, 3(1x,i2), A24)

        time=jday*1440*60 + hr*3600 + min*60 + sec

        IF(time .LT. stime) goto 65
        IF(time .GT. etime) goto 90

        ctime=time + adj

        status=time2hms( ctime, jdb, hrb, mnb, secb)

c       write new output file:
c       -----------------------
150     write(2,80) jdb, hrb, mnb, secb, string, adj
80      format(I4, '-', I2, 2(':', I2), A24, '  adj=', i4)

        end do
        goto 90
165     write(6,*)'Error on input reading!!!!'
90      continue
        end

c***********************************************************

        Integer*4 function time2hms( time, jd, hr, mn, sec)
        implicit none
        integer*4       time, jd, hr, mn, sec, rtime
        jd= time/(1440*60)
        rtime=time - jd*1440*60
        hr=rtime/3600
        rtime=rtime - hr*3600
        mn=rtime/60
        sec=rtime-mn*60

        return
        end
